Welcome everyone to the 2023 advent of code! Thank you all for stopping by and participating in it in programming.dev whether youre new to the event or doing it again.
This is an unofficial community for the event as no official spot exists on lemmy but ill be running it as best I can with Sigmatics modding as well. Ill be running a solution megathread every day where you can share solutions with other participants to compare your answers and to see the things other people come up with
Day 1: Trebuchet?!
Megathread guidelines
- Keep top level comments as only solutions, if you want to say something other than a solution put it in a new post. (replies to comments can be whatever)
- Code block support is not fully rolled out yet but likely will be in the middle of the event. Try to share solutions as both code blocks and using something such as https://topaz.github.io/paste/ or pastebin (code blocks to future proof it for when 0.19 comes out and since code blocks currently function in some apps and some instances as well if they are running a 0.19 beta)
FAQ
- What is this?: Here is a post with a large amount of details: https://programming.dev/post/6637268
- Where do I participate?: https://adventofcode.com/
- Is there a leaderboard for the community?: We have a programming.dev leaderboard with the info on how to join in this post: https://programming.dev/post/6631465
🔒This post will be unlocked when there is a decent amount of submissions on the leaderboard to avoid cheating for top spots
🔓 Edit: Post has been unlocked after 6 minutes
- sjmulder ( @sjmulder@lemmy.sdf.org ) 6•1 year ago
A new C solution: without lookahead or backtracking! I keep a running tally of how many letters of each digit word were matched so far: https://github.com/sjmulder/aoc/blob/master/2023/c/day01.c
int main(int argc, char **argv) { static const char names[][8] = {"zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine"}; int p1=0, p2=0, i,c; int p1_first = -1, p1_last = -1; int p2_first = -1, p2_last = -1; int nmatched[10] = {0}; while ((c = getchar()) != EOF) if (c == '\n') { p1 += p1_first*10 + p1_last; p2 += p2_first*10 + p2_last; p1_first = p1_last = p2_first = p2_last = -1; memset(nmatched, 0, sizeof(nmatched)); } else if (c >= '0' && c <= '9') { if (p1_first == -1) p1_first = c-'0'; if (p2_first == -1) p2_first = c-'0'; p1_last = p2_last = c-'0'; memset(nmatched, 0, sizeof(nmatched)); } else for (i=0; i<10; i++) /* advance or reset no. matched digit chars */ if (c != names[i][nmatched[i]++]) nmatched[i] = c == names[i][0]; /* matched to end? */ else if (!names[i][nmatched[i]]) { if (p2_first == -1) p2_first = i; p2_last = i; nmatched[i] = 0; } printf("%d %d\n", p1, p2); return 0; }
- sjmulder ( @sjmulder@lemmy.sdf.org ) 3•1 year ago
And golfed down:
char*N[]={0,"one","two","three","four","five","six","seven","eight","nine"};p,P, i,c,a,b;A,B;m[10];main(){while((c=getchar())>0){c==10?p+=a*10+b,P+=A*10+B,a=b=A= B=0:0;c>47&&c<58?b=B=c-48,a||(a=b),A||(A=b):0;for(i=10;--i;)c!=N[i][m[i]++]?m[i] =c==*N[i]:!N[i][m[i]]?A||(A=i),B=i:0;}printf("%d %d\n",p,P);
- perviouslyiner ( @perviouslyiner@lemm.ee ) English5•1 year ago
import re numbers = { "one" : 1, "two" : 2, "three" : 3, "four" : 4, "five" : 5, "six" : 6, "seven" : 7, "eight" : 8, "nine" : 9 } for digit in range(10): numbers[str(digit)] = digit pattern = "(%s)" % "|".join(numbers.keys()) re1 = re.compile(".*?" + pattern) re2 = re.compile(".*" + pattern) total = 0 for line in open("input.txt"): m1 = re1.match(line) m2 = re2.match(line) num = (numbers[m1.group(1)] * 10) + numbers[m2.group(1)] total += num print(total)
There weren’t any zeros in the training data I got - the text seems to suggest that “0” is allowed but “zero” isn’t.
- Gobbel2000 ( @Gobbel2000@feddit.de ) 2•1 year ago
That’s very close to how I solved part 2 as well. Using the greedy wildcard in the regex to find the last number is quite elegant.
- Gobbel2000 ( @Gobbel2000@feddit.de ) 5•1 year ago
- Andy ( @Andy@programming.dev ) 4•11 months ago
I feel ok about part 1, and just terrible about part 2.
day01.factor
on github (with comments and imports):: part1 ( -- ) "vocab:aoc-2023/day01/input.txt" utf8 file-lines [ [ [ digit? ] find nip ] [ [ digit? ] find-last nip ] bi 2array string>number ] map-sum . ; MEMO: digit-words ( -- name-char-assoc ) [ "123456789" [ dup char>name "-" split1 nip ,, ] each ] H{ } make ; : first-digit-char ( str -- num-char/f i/f ) [ digit? ] find swap ; : last-digit-char ( str -- num-char/f i/f ) [ digit? ] find-last swap ; : first-digit-word ( str -- num-char/f ) [ digit-words keys [ 2dup subseq-index dup [ [ digit-words at ] dip ,, ] [ 2drop ] if ] each drop ! ] H{ } make [ f ] [ sort-keys first last ] if-assoc-empty ; : last-digit-word ( str -- num-char/f ) reverse [ digit-words keys [ reverse 2dup subseq-index dup [ [ reverse digit-words at ] dip ,, ] [ 2drop ] if ] each drop ! ] H{ } make [ f ] [ sort-keys first last ] if-assoc-empty ; : first-digit ( str -- num-char ) dup first-digit-char dup [ pick 2dup swap head nip first-digit-word dup [ [ 2drop ] dip ] [ 2drop ] if nip ] [ 2drop first-digit-word ] if ; : last-digit ( str -- num-char ) dup last-digit-char dup [ pick 2dup swap 1 + tail nip last-digit-word dup [ [ 2drop ] dip ] [ 2drop ] if nip ] [ 2drop last-digit-word ] if ; : part2 ( -- ) "vocab:aoc-2023/day01/input.txt" utf8 file-lines [ [ first-digit ] [ last-digit ] bi 2array string>number ] map-sum . ;
- calvin ( @calvin@lemmy.calvss.com ) 4•1 year ago
I wanted to see if it was possible to do part 1 in a single line of Python:
print(sum([(([int(i) for i in line if i.isdigit()][0]) * 10 + [int(i) for i in line if i.isdigit()][-1]) for line in open("input.txt")]))
- DopeGhoti ( @DopeGhoti@infosec.exchange ) 6•1 year ago
- Adanisi ( @Adanisi@lemmy.zip ) English4•1 year ago
I’m a bit late to the party. I forgot about this.
Anyways, my (lazy) C solutions: https://git.sr.ht/~aidenisik/aoc23/tree/master/item/day1
[Rust] 11157/6740
use std::fs; const m: [(&str, u32); 10] = [ ("zero", 0), ("one", 1), ("two", 2), ("three", 3), ("four", 4), ("five", 5), ("six", 6), ("seven", 7), ("eight", 8), ("nine", 9) ]; fn main() { let s = fs::read_to_string("data/input.txt").unwrap(); let mut u = 0; for l in s.lines() { let mut h = l.chars(); let mut f = 0; let mut a = 0; for n in 0..l.len() { let u = h.next().unwrap(); match u.is_numeric() { true => { let v = u.to_digit(10).unwrap(); if f == 0 { f = v; } a = v; }, _ => { for (t, v) in m { if l[n..].starts_with(t) { if f == 0 { f = v; } a = v; } } }, } } u += f * 10 + a; } println!("Sum: {}", u); }
- learningduck ( @learningduck@programming.dev ) 2•1 year ago
Oh, doing this is Rust is really simple.
I tried doing the same thing in Rust, but ended up doing it in Python instead.
Started a bit late due to setting up the thread and monitoring the leaderboard to open it up but still got it decently quick for having barely touched rust
Probably able to get it down shorter so might revisit it
- BrucePotality ( @BrucePotality@lemmy.dbzer0.com ) 1•1 year ago
Ive been trying to learn rust for like a month now and I figured I’d try aoc with rust instead of typescript. Your solution is way better than mine and also pretty incomprehensible to me lol. I suck at rust -_-
- learningduck ( @learningduck@programming.dev ) 1•1 year ago
In case that this might help.
h.chars() returns an iterator of characters. Then he concatenate chars and see if it’s a digit or a number string.
You can swap match u.is_numeric() with if u.is_numeric and covert _ => branch to else.
- Jummit ( @Jummit@lemmy.one ) 4•1 year ago
Trickier than expected! I ran into an issue with Lua patterns, so I had to revert to a more verbose solution, which I then used in Hare as well.
Lua:
lua
-- SPDX-FileCopyrightText: 2023 Jummit -- -- SPDX-License-Identifier: GPL-3.0-or-later local sum = 0 for line in io.open("1.input"):lines() do local a, b = line:match("^.-(%d).*(%d).-$") if not a then a = line:match("%d+") b = a end if a and b then sum = sum + tonumber(a..b) end end print(sum) local names = { ["one"] = 1, ["two"] = 2, ["three"] = 3, ["four"] = 4, ["five"] = 5, ["six"] = 6, ["seven"] = 7, ["eight"] = 8, ["nine"] = 9, ["1"] = 1, ["2"] = 2, ["3"] = 3, ["4"] = 4, ["5"] = 5, ["6"] = 6, ["7"] = 7, ["8"] = 8, ["9"] = 9, } sum = 0 for line in io.open("1.input"):lines() do local firstPos = math.huge local first for name, num in pairs(names) do local left = line:find(name) if left and left < firstPos then firstPos = left first = num end end local last for i = #line, 1, -1 do for name, num in pairs(names) do local right = line:find(name, i) if right then last = num goto found end end end ::found:: sum = sum + tonumber(first * 10 + last) end print(sum)
Hare:
hare
// SPDX-FileCopyrightText: 2023 Jummit // // SPDX-License-Identifier: GPL-3.0-or-later use fmt; use types; use bufio; use strings; use io; use os; const numbers: [](str, int) = [ ("one", 1), ("two", 2), ("three", 3), ("four", 4), ("five", 5), ("six", 6), ("seven", 7), ("eight", 8), ("nine", 9), ("1", 1), ("2", 2), ("3", 3), ("4", 4), ("5", 5), ("6", 6), ("7", 7), ("8", 8), ("9", 9), ]; fn solve(start: size) void = { const file = os::open("1.input")!; defer io::close(file)!; const scan = bufio::newscanner(file, types::SIZE_MAX); let sum = 0; for (let i = 1u; true; i += 1) { const line = match (bufio::scan_line(&scan)!) { case io::EOF => break; case let line: const str => yield line; }; let first: (void | int) = void; let last: (void | int) = void; for (let i = 0z; i < len(line); i += 1) :found { for (let num = start; num < len(numbers); num += 1) { const start = strings::sub(line, i, strings::end); if (first is void && strings::hasprefix(start, numbers[num].0)) { first = numbers[num].1; }; const end = strings::sub(line, len(line) - 1 - i, strings::end); if (last is void && strings::hasprefix(end, numbers[num].0)) { last = numbers[num].1; }; if (first is int && last is int) { break :found; }; }; }; sum += first as int * 10 + last as int; }; fmt::printfln("{}", sum)!; }; export fn main() void = { solve(9); solve(0); };
- sjmulder ( @sjmulder@lemmy.sdf.org ) 4•1 year ago
Solution in C: https://github.com/sjmulder/aoc/blob/master/2023/c/day01-orig.c
Usually day 1 solutions are super short numeric things, this was a little more verbose. For part 2 I just loop over an array of digit names and use
strncmp()
.int main(int argc, char **argv) { static const char * const nm[] = {"zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine"}; char buf[64], *s; int p1=0,p2=0, p1f,p1l, p2f,p2l, d; while (fgets(buf, sizeof(buf), stdin)) { p1f = p1l = p2f = p2l = -1; for (s=buf; *s; s++) if (*s >= '0' && *s <= '9') { d = *s-'0'; if (p1f == -1) p1f = d; if (p2f == -1) p2f = d; p1l = p2l = d; } else for (d=0; d<10; d++) { if (strncmp(s, nm[d], strlen(nm[d]))) continue; if (p2f == -1) p2f = d; p2l = d; break; } p1 += p1f*10 + p1l; p2 += p2f*10 + p2l; } printf("%d %d\n", p1, p2); return 0; }
- bugsmith ( @bugsmith@programming.dev ) 4•1 year ago
Part 02 in Rust 🦀 :
use std::{ collections::HashMap, env, fs, io::{self, BufRead, BufReader}, }; fn main() -> io::Result<()> { let args: Vec = env::args().collect(); let filename = &args[1]; let file = fs::File::open(filename)?; let reader = BufReader::new(file); let number_map = HashMap::from([ ("one", "1"), ("two", "2"), ("three", "3"), ("four", "4"), ("five", "5"), ("six", "6"), ("seven", "7"), ("eight", "8"), ("nine", "9"), ]); let mut total = 0; for _line in reader.lines() { let digits = get_text_numbers(_line.unwrap(), &number_map); if !digits.is_empty() { let digit_first = digits.first().unwrap(); let digit_last = digits.last().unwrap(); let mut cat = String::new(); cat.push(*digit_first); cat.push(*digit_last); let cat: i32 = cat.parse().unwrap(); total += cat; } } println!("{total}"); Ok(()) } fn get_text_numbers(text: String, number_map: &HashMap<&str, &str>) -> Vec { let mut digits: Vec = Vec::new(); if text.is_empty() { return digits; } let mut sample = String::new(); let chars: Vec = text.chars().collect(); let mut ptr1: usize = 0; let mut ptr2: usize; while ptr1 < chars.len() { sample.clear(); ptr2 = ptr1 + 1; if chars[ptr1].is_digit(10) { digits.push(chars[ptr1]); sample.clear(); ptr1 += 1; continue; } sample.push(chars[ptr1]); while ptr2 < chars.len() { if chars[ptr2].is_digit(10) { sample.clear(); break; } sample.push(chars[ptr2]); if number_map.contains_key(&sample.as_str()) { let str_digit: char = number_map.get(&sample.as_str()).unwrap().parse().unwrap(); digits.push(str_digit); sample.clear(); break; } ptr2 += 1; } ptr1 += 1; } digits }
- snowe ( @snowe@programming.dev ) 3•1 year ago
Ruby
https://github.com/snowe2010/advent-of-code/blob/master/ruby_aoc/2023/day01/day01.rb
Part 1
execute(1, test_file_suffix: "p1") do |lines| lines.inject(0) do |acc, line| d = line.gsub(/\D/,'') acc += (d[0] + d[-1]).to_i end end
Part 2
map = { "one": 1, "two": 2, "three": 3, "four": 4, "five": 5, "six": 6, "seven": 7, "eight": 8, "nine": 9, } execute(2) do |lines| lines.inject(0) do |acc, line| first_num = line.sub(/(one|two|three|four|five|six|seven|eight|nine)/) do |key| map[key.to_sym] end last_num = line.reverse.sub(/(enin|thgie|neves|xis|evif|ruof|eerht|owt|eno)/) do |key| map[key.reverse.to_sym] end d = first_num.chars.select { |num| numeric?(num) } e = last_num.chars.select { |num| numeric?(num) } acc += (d[0] + e[0]).to_i end end
Then of course I also code golfed it, but didn’t try very hard.
P1 Code Golf
execute(1, alternative_text: "Code Golf 60 bytes", test_file_suffix: "p1") do |lines| lines.inject(0){|a,l|d=l.gsub(/\D/,'');a+=(d[0]+d[-1]).to_i} end
P2 Code Golf (ignore the formatting, I just didn’t want to reformat to remove all the spaces, and it’s easier to read this way.)
execute(1, alternative_text: "Code Golf 271 bytes", test_file_suffix: "p1") do |z| z.inject(0) { |a, l| w = %w(one two three four five six seven eight nine) x = w.join(?|) f = l.sub(/(#{x})/) { |k| map[k.to_sym] } g = l.reverse.sub(/(#{x.reverse})/) { |k| map[k.reverse.to_sym] } d = f.chars.select { |n| n.match?(/\d/) } e = g.chars.select { |n| n.match?(/\d/) } a += (d[0] + e[0]).to_i } end
- cabhan ( @cabhan@discuss.tchncs.de ) 3•1 year ago
Thank you for sharing this. I also wrote a regular expression with
\d|eno|owt
and so on, and I was not so proud of myself :). Good to know I wasn’t the only one :).- snowe ( @snowe@programming.dev ) 1•1 year ago
haha it’s such a dumb solution, but it works. i’ve seen several others that have done the same thing. The alternatives all sounded too hard for my tired brain.
- stifle867 ( @stifle867@programming.dev ) 1•1 year ago
I was trying so hard to avoid doing this and landed on a pretty nice solution (for me). It’s funny sering everyone’s approach especially when you have no problem running through that barrier that I didn’t want to 😆
- Tom ( @thtroyer@programming.dev ) 3•1 year ago
Java
My take on a modern Java solution (parts 1 & 2).
spoiler
package thtroyer.day1; import java.util.*; import java.util.stream.IntStream; import java.util.stream.Stream; public class Day1 { record Match(int index, String name, int value) { } Map numbers = Map.of( "one", 1, "two", 2, "three", 3, "four", 4, "five", 5, "six", 6, "seven", 7, "eight", 8, "nine", 9); /** * Takes in all lines, returns summed answer */ public int getCalibrationValue(String... lines) { return Arrays.stream(lines) .map(this::getCalibrationValue) .map(Integer::parseInt) .reduce(0, Integer::sum); } /** * Takes a single line and returns the value for that line, * which is the first and last number (numerical or text). */ protected String getCalibrationValue(String line) { var matches = Stream.concat( findAllNumberStrings(line).stream(), findAllNumerics(line).stream() ).sorted(Comparator.comparingInt(Match::index)) .toList(); return "" + matches.getFirst().value() + matches.getLast().value(); } /** * Find all the strings of written numbers (e.g. "one") * * @return List of Matches */ private List findAllNumberStrings(String line) { return IntStream.range(0, line.length()) .boxed() .map(i -> findAMatchAtIndex(line, i)) .filter(Optional::isPresent) .map(Optional::get) .sorted(Comparator.comparingInt(Match::index)) .toList(); } private Optional findAMatchAtIndex(String line, int index) { return numbers.entrySet().stream() .filter(n -> line.indexOf(n.getKey(), index) == index) .map(n -> new Match(index, n.getKey(), n.getValue())) .findAny(); } /** * Find all the strings of digits (e.g. "1") * * @return List of Matches */ private List findAllNumerics(String line) { return IntStream.range(0, line.length()) .boxed() .filter(i -> Character.isDigit(line.charAt(i))) .map(i -> new Match(i, null, Integer.parseInt(line.substring(i, i + 1)))) .toList(); } public static void main(String[] args) { System.out.println(new Day1().getCalibrationValue(args)); } }
- stifle867 ( @stifle867@programming.dev ) 3•1 year ago
My solutin in Elixir for both part 1 and part 2 is below. It does use regex and with that there are many different ways to accomplish the goal. I’m no regex master so I made it as simple as possible and relied on the language a bit more. I’m sure there are cooler solutions with no regex too, this is just what I settled on:
https://pastebin.com/u1SYJ4tY
defmodule AdventOfCode.Day01 do def part1(args) do number_regex = ~r/([0-9])/ args |> String.split(~r/\n/, trim: true) |> Enum.map(&first_and_last_number(&1, number_regex)) |> Enum.map(&number_list_to_integer/1) |> Enum.sum() end def part2(args) do number_regex = ~r/(?=(one|two|three|four|five|six|seven|eight|nine|[0-9]))/ args |> String.split(~r/\n/, trim: true) |> Enum.map(&first_and_last_number(&1, number_regex)) |> Enum.map(fn number -> Enum.map(number, &replace_word_with_number/1) end) |> Enum.map(&number_list_to_integer/1) |> Enum.sum() end defp first_and_last_number(string, regex) do matches = Regex.scan(regex, string) [_, first] = List.first(matches) [_, last] = List.last(matches) [first, last] end defp number_list_to_integer(list) do list |> List.to_string() |> String.to_integer() end defp replace_word_with_number(string) do numbers = ["one", "two", "three", "four", "five", "six", "seven", "eight", "nine"] String.replace(string, numbers, fn x -> (Enum.find_index(numbers, &(&1 == x)) + 1) |> Integer.to_string() end) end end
- CameronDev ( @CameronDev@programming.dev ) 3•1 year ago
I did this in C. First part was fairly trivial, iterate over the line, find first and last number, easy.
Second part had me a bit worried i would need a more string friendly library/language, until i worked out that i can just
strstr
to find “one”, and then in place switch that to “o1e”, and so on. Then run part1 code over the modified buffer. I originally did “1ne”, but overlaps such as “eightwo” meant that i got the 2, but missed the 8.#include #include #include #include #include size_t readfile(char* fname, char* buffer, size_t buffer_len) { int f = open(fname, 'r'); assert(f >= 0); size_t total = 0; do { size_t nr = read(f, buffer + total, buffer_len - total); if (nr == 0) { return total; } total += nr; } while (buffer_len - total > 0); return -1; } int part1(const char* buffer, size_t buffer_len) { int first = -1; int last = -1; int total = 0; for (int i = 0; i < buffer_len; i++) { char c = buffer[i]; if (c == '\n') { if (first == -1) { continue; } total += (first*10 + last); first = last = -1; continue; } int val = c - '0'; if (val > 9 || val < 0) { continue; } if (first == -1) { first = last = val; } else { last = val; } } return total; } void part2_sanitize(char* buffer, size_t len) { char* p = NULL; while ((p = strnstr(buffer, "one", len)) != NULL) { p[1] = '1'; } while ((p = strnstr(buffer, "two", len)) != NULL) { p[1] = '2'; } while ((p = strnstr(buffer, "three", len)) != NULL) { p[1] = '3'; } while ((p = strnstr(buffer, "four", len)) != NULL) { p[1] = '4'; } while ((p = strnstr(buffer, "five", len)) != NULL) { p[1] = '5'; } while ((p = strnstr(buffer, "six", len)) != NULL) { p[1] = '6'; } while ((p = strnstr(buffer, "seven", len)) != NULL) { p[1] = '7'; } while ((p = strnstr(buffer, "eight", len)) != NULL) { p[1] = '8'; } while ((p = strnstr(buffer, "nine", len)) != NULL) { p[1] = '9'; } while ((p = strnstr(buffer, "zero", len)) != NULL) { p[1] = '0'; } } int main(int argc, char** argv) { assert(argc == 2); char buffer[1000000]; size_t len = readfile(argv[1], buffer, sizeof(buffer)); { int total = part1(buffer, len); printf("Part 1 total: %i\n", total); } { part2_sanitize(buffer, len); int total = part1(buffer, len); printf("Part 2 total: %i\n", total); } }
- CameronDev ( @CameronDev@programming.dev ) 3•1 year ago
Just realised how inefficient the sanitize function is, it iterates over the buffer way too many times. Should be restarting the strnstr from the location of the last hit instead of from the start.
- Joey ( @Joey@programming.dev ) 3•1 year ago
My solution in rust. I’m sure there’s a lot more clever ways to do it but this is what I came up with.
Code
use std::{io::prelude::*, fs::File, path::Path, io }; fn main() { run_solution(false); println!("\nPress enter to continue"); let mut buffer = String::new(); io::stdin().read_line(&mut buffer).unwrap(); run_solution(true); } fn run_solution(check_for_spelled: bool) { let data = load_data("data/input"); println!("\nProcessing Data..."); let mut sum: u64 = 0; for line in data.lines() { // Doesn't seem like the to_ascii_lower call is needed but... just in case let first = get_digit(line.to_ascii_lowercase().as_bytes(), false, check_for_spelled); let last = get_digit(line.to_ascii_lowercase().as_bytes(), true, check_for_spelled); let num = (first * 10) + last; // println!("\nLine: {} -- First: {}, Second: {}, Num: {}", line, first, last, num); sum += num as u64; } println!("\nFinal Sum: {}", sum); } fn get_digit(line: &[u8], from_back: bool, check_for_spelled: bool) -> u8 { let mut range: Vec = (0..line.len()).collect(); if from_back { range.reverse(); } for i in range { if is_num(line[i]) { return (line[i] - 48) as u8; } if check_for_spelled { if let Some(num) = is_spelled_num(line, i) { return num; } } } return 0; } fn is_num(c: u8) -> bool { c >= 48 && c <= 57 } fn is_spelled_num(line: &[u8], start: usize) -> Option { let words = ["one", "two", "three", "four", "five", "six", "seven", "eight", "nine"]; for word_idx in 0..words.len() { let mut i = start; let mut found = true; for c in words[word_idx].as_bytes() { if i < line.len() && *c != line[i] { found = false; break; } i += 1; } if found && i <= line.len() { return Some(word_idx as u8 + 1); } } return None; } fn load_data(file_name: &str) -> String { let mut file = match File::open(Path::new(file_name)) { Ok(file) => file, Err(why) => panic!("Could not open file {}: {}", Path::new(file_name).display(), why), }; let mut s = String::new(); let file_contents = match file.read_to_string(&mut s) { Err(why) => panic!("couldn't read {}: {}", Path::new(file_name).display(), why), Ok(_) => s, }; return file_contents; }